/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.records;


import com.tabajara.base.tables.Hisatuacao;
import com.tabajara.base.tables.interfaces.IHisatuacao;

import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import java.sql.Date;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record8;
import org.jooq.Row8;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class HisatuacaoRecord extends UpdatableRecordImpl<HisatuacaoRecord> implements VertxPojo, Record8<Integer, Integer, Integer, Integer, Integer, String, Date, String>, IHisatuacao {

    private static final long serialVersionUID = 1360872363;

    /**
     * Setter for <code>public.hisatuacao.histatuaid</code>.
     */
    @Override
    public HisatuacaoRecord setHistatuaid(Integer value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>public.hisatuacao.histatuaid</code>.
     */
    @Override
    public Integer getHistatuaid() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>public.hisatuacao.fkardid</code>.
     */
    @Override
    public HisatuacaoRecord setFkardid(Integer value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>public.hisatuacao.fkardid</code>.
     */
    @Override
    public Integer getFkardid() {
        return (Integer) get(1);
    }

    /**
     * Setter for <code>public.hisatuacao.fktanid</code>.
     */
    @Override
    public HisatuacaoRecord setFktanid(Integer value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>public.hisatuacao.fktanid</code>.
     */
    @Override
    public Integer getFktanid() {
        return (Integer) get(2);
    }

    /**
     * Setter for <code>public.hisatuacao.fkatuid</code>.
     */
    @Override
    public HisatuacaoRecord setFkatuid(Integer value) {
        set(3, value);
        return this;
    }

    /**
     * Getter for <code>public.hisatuacao.fkatuid</code>.
     */
    @Override
    public Integer getFkatuid() {
        return (Integer) get(3);
    }

    /**
     * Setter for <code>public.hisatuacao.fkempid</code>.
     */
    @Override
    public HisatuacaoRecord setFkempid(Integer value) {
        set(4, value);
        return this;
    }

    /**
     * Getter for <code>public.hisatuacao.fkempid</code>.
     */
    @Override
    public Integer getFkempid() {
        return (Integer) get(4);
    }

    /**
     * Setter for <code>public.hisatuacao.hora</code>.
     */
    @Override
    public HisatuacaoRecord setHora(String value) {
        set(5, value);
        return this;
    }

    /**
     * Getter for <code>public.hisatuacao.hora</code>.
     */
    @Override
    public String getHora() {
        return (String) get(5);
    }

    /**
     * Setter for <code>public.hisatuacao.dia</code>.
     */
    @Override
    public HisatuacaoRecord setDia(Date value) {
        set(6, value);
        return this;
    }

    /**
     * Getter for <code>public.hisatuacao.dia</code>.
     */
    @Override
    public Date getDia() {
        return (Date) get(6);
    }

    /**
     * Setter for <code>public.hisatuacao.medida</code>.
     */
    @Override
    public HisatuacaoRecord setMedida(String value) {
        set(7, value);
        return this;
    }

    /**
     * Getter for <code>public.hisatuacao.medida</code>.
     */
    @Override
    public String getMedida() {
        return (String) get(7);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record8 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row8<Integer, Integer, Integer, Integer, Integer, String, Date, String> fieldsRow() {
        return (Row8) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row8<Integer, Integer, Integer, Integer, Integer, String, Date, String> valuesRow() {
        return (Row8) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return Hisatuacao.HISATUACAO.HISTATUAID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field2() {
        return Hisatuacao.HISATUACAO.FKARDID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field3() {
        return Hisatuacao.HISATUACAO.FKTANID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field4() {
        return Hisatuacao.HISATUACAO.FKATUID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field5() {
        return Hisatuacao.HISATUACAO.FKEMPID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field6() {
        return Hisatuacao.HISATUACAO.HORA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Date> field7() {
        return Hisatuacao.HISATUACAO.DIA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field8() {
        return Hisatuacao.HISATUACAO.MEDIDA;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getHistatuaid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component2() {
        return getFkardid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component3() {
        return getFktanid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component4() {
        return getFkatuid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component5() {
        return getFkempid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component6() {
        return getHora();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Date component7() {
        return getDia();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component8() {
        return getMedida();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getHistatuaid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value2() {
        return getFkardid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value3() {
        return getFktanid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value4() {
        return getFkatuid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value5() {
        return getFkempid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value6() {
        return getHora();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Date value7() {
        return getDia();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value8() {
        return getMedida();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HisatuacaoRecord value1(Integer value) {
        setHistatuaid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HisatuacaoRecord value2(Integer value) {
        setFkardid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HisatuacaoRecord value3(Integer value) {
        setFktanid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HisatuacaoRecord value4(Integer value) {
        setFkatuid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HisatuacaoRecord value5(Integer value) {
        setFkempid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HisatuacaoRecord value6(String value) {
        setHora(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HisatuacaoRecord value7(Date value) {
        setDia(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HisatuacaoRecord value8(String value) {
        setMedida(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public HisatuacaoRecord values(Integer value1, Integer value2, Integer value3, Integer value4, Integer value5, String value6, Date value7, String value8) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        return this;
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public void from(IHisatuacao from) {
        setHistatuaid(from.getHistatuaid());
        setFkardid(from.getFkardid());
        setFktanid(from.getFktanid());
        setFkatuid(from.getFkatuid());
        setFkempid(from.getFkempid());
        setHora(from.getHora());
        setDia(from.getDia());
        setMedida(from.getMedida());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public <E extends IHisatuacao> E into(E into) {
        into.from(this);
        return into;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached HisatuacaoRecord
     */
    public HisatuacaoRecord() {
        super(Hisatuacao.HISATUACAO);
    }

    /**
     * Create a detached, initialised HisatuacaoRecord
     */
    public HisatuacaoRecord(Integer histatuaid, Integer fkardid, Integer fktanid, Integer fkatuid, Integer fkempid, String hora, Date dia, String medida) {
        super(Hisatuacao.HISATUACAO);

        set(0, histatuaid);
        set(1, fkardid);
        set(2, fktanid);
        set(3, fkatuid);
        set(4, fkempid);
        set(5, hora);
        set(6, dia);
        set(7, medida);
    }

    public HisatuacaoRecord(io.vertx.core.json.JsonObject json) {
        this();
        fromJson(json);
    }
}
